/**
 **	File ......... Socks4Socket.h
 **	Published ....  2005-03-23
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _SOCKS4SOCKET_H
#define _SOCKS4SOCKET_H

#include <TcpSocket.h>
#include <SocketHandler.h>

#define MAXLEN_USERID 1000

class RemoteSocket;

class Socks4Socket : public TcpSocket
{
	enum state_t {
		STATE_VN = 0,
		STATE_CD,
		STATE_DSTPORT,
		STATE_DSTIP,
		STATE_USERID,
		STATE_TRY_CONNECT,
		STATE_CONNECTED,
		STATE_FAILED,
		STATE_ACCEPT,
	};
public:
	Socks4Socket(SocketHandler& );
	~Socks4Socket();

	void OnAccept() {
		printf("Incoming\n");
	}
	void OnRead();

	void Connected();
	void ConnectFailed();
	void Accept();

	void SetRemote(RemoteSocket *p) { m_pRemote = p; }

private:
	Socks4Socket(const Socks4Socket& s) : TcpSocket(s) {} // copy constructor
	Socks4Socket& operator=(const Socks4Socket& ) { return *this; } // assignment operator
	void SetupConnect();
	void SetupBind();

	int m_state;
	char m_vn;
	char m_cd;
	unsigned short m_dstport;
	unsigned long m_dstip;
	char m_userid[MAXLEN_USERID];
	int m_userid_ptr;
	RemoteSocket *m_pRemote;
};




#endif // _SOCKS4SOCKET_H
